package ovh.herisson.Clyde.Services;

import org.springframework.stereotype.Service;
import ovh.herisson.Clyde.Repositories.TokenRepository;
import ovh.herisson.Clyde.Tables.Token;
import ovh.herisson.Clyde.Tables.User;

import java.nio.charset.StandardCharsets;
import java.security.SecureRandom;
import java.util.Date;

@Service
public class TokenService {

    TokenRepository tokenRepo;

    public TokenService(TokenRepository tokenRepo){
        this.tokenRepo = tokenRepo;
    }


    public String generateNewToken(){
        byte[] bytes = new byte[64];
        new SecureRandom().nextBytes(bytes);
        String token = new String(bytes, StandardCharsets.US_ASCII);
        System.out.println(token);
        return token;
    }

    public User getUserFromToken(String token){
        return tokenRepo.getByToken(token).getUser();
    }

    public void saveToken(String token, User user, Date expirationDate){// todo faire qlq chose de l'expDate
        tokenRepo.save(new Token(user,token));
    }
}